<template>
    <v-stepper v-model="stepper" vertical>
        <v-stepper-step :complete="stepper > 1" step="1">
            Kopfdaten
        </v-stepper-step>

        <v-stepper-content step="1">
            <v-form ref="headerDataForm" v-model="validHeaderData">
                <v-text-field
                        v-model="headerData.teacher"
                        label="Lehrperson"
                        :rules="rules.teacher"
                        required
                ></v-text-field>

                <v-text-field
                        v-model="headerData.subject"
                        label="Unterrichtsfach"
                        :rules="rules.subject"
                        required
                ></v-text-field>

                <v-btn
                        @click="validateHeaderData"
                >
                    Weiter
                </v-btn>
            </v-form>
        </v-stepper-content>

        <v-stepper-step :complete="stepper > 2" step="2">
            Soziale Beziehungen (Umgang)
        </v-stepper-step>

        <v-stepper-content step="2">
            <question
                    v-for="(question, index) in questions['social']"
                    :key="index"
                    v-model="questionData['social'][index]"
                    :question="question"
            ></question>
            <v-btn
                    @click="stepper += 1"
            >
                Weiter
            </v-btn>
        </v-stepper-content>

        <v-stepper-step :complete="stepper > 3" step="3">
            Unterricht
        </v-stepper-step>

        <v-stepper-content step="3">
            <question
                    v-for="(question, index) in questions['teaching']"
                    :key="index"
                    v-model="questionData['teaching'][index]"
                    :question="question"
            ></question>
            <v-btn
                    @click="stepper += 1"
            >
                Weiter
            </v-btn>
        </v-stepper-content>

        <v-stepper-step :complete="stepper > 4" step="4">
            Prüfen und Beurteilen
        </v-stepper-step>

        <v-stepper-content step="4">
            <question
                    v-for="(question, index) in questions['grading']"
                    :key="index"
                    v-model="questionData['grading'][index]"
                    :question="question"
            ></question>
            <v-btn
                    @click="stepper += 1"
            >
                Weiter
            </v-btn>
        </v-stepper-content>

        <v-stepper-step :complete="stepper > 5" step="5">
            Bemerkungen
        </v-stepper-step>

        <v-stepper-content step="5">
            <v-textarea
                    v-model="remarks"
                    name="remarks"
                    label="Remarks"
                    hint="Ergänzende, spezifische Rückmeldungen sind besonders hilfreich...!"
            ></v-textarea>
            <v-radio-group v-model="sendUserData" column>
                <v-radio label="Feedback anonym senden" value="anonymous"></v-radio>
                <v-radio label="Feedback mit Namen senden" value="withName"></v-radio>
            </v-radio-group>
            <v-btn
                    @click="submitData"
            >
                Feedback absenden
            </v-btn>
        </v-stepper-content>


    </v-stepper>
</template>

<script lang="ts">
    // eslint-disable-next-line no-unused-vars
    import {db} from '../main'
    import Question from '../components/Question'
    import questions from '../questions'

    export default {
        components: {
            'question': Question
        },
        data: () => ({
            stepper: 1,
            validHeaderData: false,
            headerData: {
                teacher: '',
                data: null,
                subject: ''
            },
            questions: questions,
            questionData: {
                'social': Array(questions['social'].length).fill(2),
                'teaching': Array(questions['teaching'].length).fill(2),
                'grading': Array(questions['grading'].length).fill(2),
            },
            remarks: '',
            sendUserData: null,
            rules: {
                teacher: [
                    v => !!v || "Gib den Namen der Lehrperson an!"
                ],
                subject: [
                    v => !!v || "Gib das Unterrichtsfach an!"
                ]
            }
        }),
        mounted() {
            this.$emit('updateToolbarTitle', 'Fragebogen');
        },
        methods: {
            validateHeaderData() {
                if (this.$refs.headerDataForm.validate()) {
                    this.stepper = 2;
                }
            },

            submitData() {

                console.error('This function is not implemented yet...!');

                /**
                 * TODO: Implemement the submission of all data!
                 *
                 * Create a new document FOR EVERY SINGLE QUESTIONN containing
                 *  - teacher: name of teacher
                 *  - subject: name of subject
                 *  - moment: current date and time
                 *  - questionId: the question id (e.g. social-1, teaching-5, ..., remarks)
                 *  - questionText: the questions text itself
                 *  - depending on type of question:
                 *      - rating: answer of the user as value 1-5
                 *      - remarks: remark(s) of the user (if available)
                 *  - if the user gave permission
                 *      - userId: id of user
                 *      - usersName: full name of user
                 *
                 * The documents should be persisted with a randomly generated document id (by firestore)
                 * in collection: feedbacks/_userId_/answers
                 */

                    // Use the following data to initialize a template for all documents
                const userId = this.$root.$data.user.uid;
                const usersName = this.$root.$data.usersName;

                const documentTemplate = {
                    teacher: this.headerData.teacher,
                    subject: this.headerData.subject,
                    moment: new Date()
                };

                // Add user data to the document template if the user gave consent
                if (this.sendUserData === 'withName') {
                    documentTemplate['userId'] = userId;
                    documentTemplate['usersName'] = usersName;
                }

                /**
                 * Go on...
                 *
                 * Use the documentTemplate for creating individual documents for every answer...
                 * Here's a proposal on how to continue:
                 *
                 *  1) Loop (for) over the entries of the objects which contains the answer data.
                 *     See line 129 of this file for how the answer data is structured.
                 *      --> for ( ... Object.entries(this.questionData)) { ... }
                 *
                 *  2) For every answer: "Clone" the template document and add question specific data:
                 *      --> loop over answers: data.forEach( ... )
                 *      --> clone: Object.assign({}, documentTemplate)
                 *
                 *  3) Store the complete document in the Cloud Firestore Database
                 *      --> db.collection(...)...
                 */

                // use this prepared collection path to store all documents in the collection
                // eslint-disable-next-line no-unused-vars
                const collectionPath = `feedbacks/${userId}/answers`;

                // eslint-disable-next-line no-unused-vars
                for (const [categoryName, data] of Object.entries(this.questionData)) {
                    //
                }


                // Remember: There are answers (for closed questions) and also remarks!

            }
        }
    }
</script>

<style scoped>

</style>